diff -u -r gdm-2.28.2.pristine/gui/simple-greeter/gdm-user-manager.c gdm-2.28.2/gui/simple-greeter/gdm-user-manager.c
--- gdm-2.28.2.pristine/gui/simple-greeter/gdm-user-manager.c	2010-01-22 11:17:50.731384714 -0500
+++ gdm-2.28.2/gui/simple-greeter/gdm-user-manager.c	2010-01-24 16:57:33.169124287 -0500
@@ -505,282 +368,99 @@
 }
 
 static void
-on_user_icon_changed (GdmUser        *user,
-                      GdmUserManager *manager)
-{
-        g_debug ("GdmUserManager: user icon changed");
-}
-
-static char *
-get_seat_id_for_session (DBusGConnection *connection,
-                         const char      *session_id)
+user_added_handler (DBusGProxy *proxy,
+                    const char *object_path,
+                    gpointer    user_data)
 {
-        DBusGProxy      *proxy;
-        GError          *error;
-        char            *seat_id;
-        gboolean         res;
-
-        proxy = NULL;
-        seat_id = NULL;
+        GdmUserManager *manager = GDM_USER_MANAGER (user_data);
+        GdmUser *user;
+        GdmUser *dup;
 
-        proxy = dbus_g_proxy_new_for_name (connection,
-                                           CK_NAME,
-                                           session_id,
-                                           CK_SESSION_INTERFACE);
-        if (proxy == NULL) {
-                g_warning ("Failed to connect to the ConsoleKit session object");
-                goto out;
-        }
+        if (g_hash_table_lookup (manager->user_by_object_path, object_path))
+                return;
 
-        error = NULL;
-        res = dbus_g_proxy_call (proxy,
-                                 "GetSeatId",
-                                 &error,
-                                 G_TYPE_INVALID,
-                                 DBUS_TYPE_G_OBJECT_PATH, &seat_id,
-                                 G_TYPE_INVALID);
-        if (! res) {
-                if (error != NULL) {
-                        g_debug ("Failed to identify the current seat: %s", error->message);
-                        g_error_free (error);
-                } else {
-                        g_debug ("Failed to identify the current seat");
-                }
-        }
- out:
-        if (proxy != NULL) {
-                g_object_unref (proxy);
+        user = gdm_user_new_from_object_path (object_path);
+        g_signal_connect (user, "sessions-changed",
+                          G_CALLBACK (on_user_sessions_changed), manager);
+        add_sessions_for_user (manager, user);
+        dup = g_hash_table_find (manager->user_by_object_path,
+                                 match_real_name_hrfunc,
+                                 user);
+        if (dup != NULL) {
+                _gdm_user_show_full_display_name (user);
+                _gdm_user_show_full_display_name (dup);
         }
 
-        return seat_id;
+        g_signal_connect (user, "changed",
+                          G_CALLBACK (user_changed_handler), manager);
+        g_hash_table_insert (manager->user_by_object_path, (gpointer)gdm_user_get_object_path (user), g_object_ref (user));
+        g_hash_table_insert (manager->user_by_name, (gpointer)gdm_user_get_user_name (user), g_object_ref (user));
+        g_signal_emit (manager, signals[USER_ADDED], 0, user);
+        g_object_unref (user);
 }
 
-static char *
-get_x11_display_for_session (DBusGConnection *connection,
-                             const char      *session_id)
+static void
+user_deleted_handler (DBusGProxy *proxy,
+                      const char *object_path,
+                      gpointer    user_data)
 {
-        DBusGProxy      *proxy;
-        GError          *error;
-        char            *x11_display;
-        gboolean         res;
-
-        proxy = NULL;
-        x11_display = NULL;
-
-        proxy = dbus_g_proxy_new_for_name (connection,
-                                           CK_NAME,
-                                           session_id,
-                                           CK_SESSION_INTERFACE);
-        if (proxy == NULL) {
-                g_warning ("Failed to connect to the ConsoleKit session object");
-                goto out;
-        }
-
-        error = NULL;
-        res = dbus_g_proxy_call (proxy,
-                                 "GetX11Display",
-                                 &error,
-                                 G_TYPE_INVALID,
-                                 G_TYPE_STRING, &x11_display,
-                                 G_TYPE_INVALID);
-        if (! res) {
-                if (error != NULL) {
-                        g_debug ("Failed to identify the x11 display: %s", error->message);
-                        g_error_free (error);
-                } else {
-                        g_debug ("Failed to identify the x11 display");
-                }
-        }
- out:
-        if (proxy != NULL) {
-                g_object_unref (proxy);
-        }
+        GdmUserManager *manager = GDM_USER_MANAGER (user_data);
+        GdmUser *user;
 
-        return x11_display;
+        user = g_hash_table_lookup (manager->user_by_object_path, object_path);
+        g_object_ref (user);
+        g_signal_handlers_disconnect_by_func (user, user_changed_handler, manager);
+        g_hash_table_remove (manager->user_by_object_path, gdm_user_get_object_path (user));
+        g_hash_table_remove (manager->user_by_name, gdm_user_get_user_name (user));
+        g_signal_emit (manager, signals[USER_REMOVED], 0, user);
+        g_object_unref (user);
 }
 
-static gboolean
-maybe_add_session_for_user (GdmUserManager *manager,
-                            GdmUser        *user,
-                            const char     *ssid)
+static void
+add_user (const gchar   *object_path,
+          GdmUserManager *manager)
 {
-        char    *sid;
-        char    *x11_display;
-        gboolean ret;
-
-        ret = FALSE;
-        sid = NULL;
-        x11_display = NULL;
-
-        /* skip if on another seat */
-        sid = get_seat_id_for_session (manager->priv->connection, ssid);
-        if (sid == NULL
-            || manager->priv->seat_id == NULL
-            || strcmp (sid, manager->priv->seat_id) != 0) {
-                g_debug ("GdmUserManager: not adding session on other seat: %s", ssid);
-                goto out;
-        }
-
-        /* skip if doesn't have an x11 display */
-        x11_display = get_x11_display_for_session (manager->priv->connection, ssid);
-        if (x11_display == NULL || x11_display[0] == '\0') {
-                g_debug ("GdmUserManager: not adding session without a x11 display: %s", ssid);
-                goto out;
-        }
-
-        if (g_hash_table_lookup (manager->priv->exclusions, gdm_user_get_user_name (user))) {
-                g_debug ("GdmUserManager: excluding user '%s'", gdm_user_get_user_name (user));
-                goto out;
-        }
-
-        g_hash_table_insert (manager->priv->sessions,
-                             g_strdup (ssid),
-                             g_strdup (gdm_user_get_user_name (user)));
-
-        _gdm_user_add_session (user, ssid);
-        g_debug ("GdmUserManager: added session for user: %s", gdm_user_get_user_name (user));
-
-        ret = TRUE;
-
- out:
-        g_free (sid);
-        g_free (x11_display);
-
-        return ret;
+        user_added_handler (NULL, object_path, manager);
 }
 
 static void
-add_sessions_for_user (GdmUserManager *manager,
-                       GdmUser        *user)
+got_users (DBusGProxy     *proxy,
+           DBusGProxyCall *call_id,
+           gpointer        data)
 {
-        DBusGProxy      *proxy;
-        GError          *error;
-        gboolean         res;
-        guint32          uid;
-        GPtrArray       *sessions;
-        int              i;
-
-        proxy = dbus_g_proxy_new_for_name (manager->priv->connection,
-                                           CK_NAME,
-                                           CK_MANAGER_PATH,
-                                           CK_MANAGER_INTERFACE);
-        if (proxy == NULL) {
-                g_warning ("Failed to connect to the ConsoleKit manager object");
-                goto out;
-        }
-
-        uid = gdm_user_get_uid (user);
-
-        g_debug ("Getting list of sessions for user %u", uid);
-
-        error = NULL;
-        res = dbus_g_proxy_call (proxy,
-                                 "GetSessionsForUnixUser",
-                                 &error,
-                                 G_TYPE_UINT, uid,
-                                 G_TYPE_INVALID,
-                                 dbus_g_type_get_collection ("GPtrArray", DBUS_TYPE_G_OBJECT_PATH),
-                                 &sessions,
-                                 G_TYPE_INVALID);
-        if (! res) {
-                if (error != NULL) {
-                        g_debug ("Failed to find sessions for user: %s", error->message);
-                        g_error_free (error);
-                } else {
-                        g_debug ("Failed to find sessions for user");
-                }
-                goto out;
-        }
+        GdmUserManager *manager = data;
+        GError *error = NULL;
+        GPtrArray *paths;
 
-        g_debug ("Found %d sessions for user %s", sessions->len, gdm_user_get_user_name (user));
-
-        for (i = 0; i < sessions->len; i++) {
-                char *ssid;
-
-                ssid = g_ptr_array_index (sessions, i);
-                maybe_add_session_for_user (manager, user, ssid);
-        }
-
-        g_ptr_array_foreach (sessions, (GFunc)g_free, NULL);
-        g_ptr_array_free (sessions, TRUE);
-
- out:
-        if (proxy != NULL) {
-                g_object_unref (proxy);
+        if (!dbus_g_proxy_end_call (proxy,
+                                    call_id,
+                                    &error,
+                                    dbus_g_type_get_collection ("GPtrArray", DBUS_TYPE_G_OBJECT_PATH), &paths,
+                                    G_TYPE_INVALID)) {
+                manager->no_service = TRUE;
+                g_error_free (error);
+                goto done;
         }
-}
 
-static GdmUser *
-create_user (GdmUserManager *manager)
-{
-        GdmUser *user;
-
-        user = g_object_new (GDM_TYPE_USER, "manager", manager, NULL);
-        g_signal_connect (user,
-                          "sessions-changed",
-                          G_CALLBACK (on_user_sessions_changed),
-                          manager);
-        g_signal_connect (user,
-                          "icon-changed",
-                          G_CALLBACK (on_user_icon_changed),
-                          manager);
-        return user;
-}
-
-static gint
-match_real_name_cmpfunc (gconstpointer a,
-                         gconstpointer b)
-{
-        if (a == b)
-                return -1;
+        g_ptr_array_foreach (paths, (GFunc)add_user, manager);
 
-        return g_strcmp0 (gdm_user_get_real_name ((GdmUser *) a),
-                          gdm_user_get_real_name ((GdmUser *) b));
-}
+        g_ptr_array_foreach (paths, (GFunc)g_free, NULL);
+        g_ptr_array_free (paths, TRUE);
 
-static gboolean
-match_real_name_hrfunc (gpointer key,
-                        gpointer value,
-                        gpointer user_data)
-{
-        return (g_strcmp0 (user_data, gdm_user_get_real_name (value)) == 0);
+ done:
+        g_signal_emit (G_OBJECT (manager), signals[USERS_LOADED], 0);
 }
 
 static void
-add_user (GdmUserManager *manager,
-          GdmUser        *user)
-{
-        GdmUser *dup;
-
-        add_sessions_for_user (manager, user);
-        dup = g_hash_table_find (manager->priv->users,
-                                 match_real_name_hrfunc,
-                                 (char *) gdm_user_get_real_name (user));
-        if (dup != NULL) {
-                _gdm_user_show_full_display_name (user);
-                _gdm_user_show_full_display_name (dup);
-        }
-        g_hash_table_insert (manager->priv->users,
-                             g_strdup (gdm_user_get_user_name (user)),
-                             g_object_ref (user));
-
-        g_signal_emit (manager, signals[USER_ADDED], 0, user);
-}
-
-static GdmUser *
-add_new_user_for_pwent (GdmUserManager *manager,
-                        struct passwd  *pwent)
+get_users (GdmUserManager *manager)
 {
-        GdmUser *user;
-
-        g_debug ("Creating new user");
-
-        user = create_user (manager);
-        _gdm_user_update (user, pwent);
-
-        add_user (manager, user);
-
-        return user;
+        g_debug ("calling 'ListCachedUsers'");
+        dbus_g_proxy_begin_call (manager->proxy,
+                                 "ListCachedUsers",
+                                 got_users,
+                                 manager,
+                                 NULL,
+                                 G_TYPE_INVALID);
 }
 
 static char *
@@ -824,7 +504,6 @@
         }
 
         seat_id = get_seat_id_for_session (connection, session_id);
-
  out:
         if (proxy != NULL) {
                 g_object_unref (proxy);
@@ -844,7 +523,7 @@
         guint            uid;
         gboolean         res;
 
-        proxy = dbus_g_proxy_new_for_name (manager->priv->connection,
+        proxy = dbus_g_proxy_new_for_name (manager->bus,
                                            CK_NAME,
                                            session_id,
                                            CK_SESSION_INTERFACE);
@@ -905,19 +584,19 @@
                 return;
         }
 
+#if 0
         /* check exclusions up front */
         if (g_hash_table_lookup (manager->priv->exclusions, pwent->pw_name)) {
                 g_debug ("GdmUserManager: excluding user '%s'", pwent->pw_name);
                 return;
         }
+#endif
 
-        user = g_hash_table_lookup (manager->priv->users, pwent->pw_name);
+        user = g_hash_table_lookup (manager->user_by_name, pwent->pw_name);
         if (user == NULL) {
-                g_debug ("Creating new user");
-
-                user = create_user (manager);
-                _gdm_user_update (user, pwent);
                 is_new = TRUE;
+                /* TODO call service to look up user */
+                return;
         } else {
                 is_new = FALSE;
         }
@@ -926,11 +605,13 @@
 
         /* only add the user if we added a session */
         if (is_new) {
+#if 0
                 if (res) {
                         add_user (manager, user);
                 } else {
                         g_object_unref (user);
                 }
+#endif
         }
 }
 
@@ -945,14 +626,14 @@
         g_debug ("Session removed: %s", session_id);
 
         /* since the session object may already be gone
-         * we can't query CK directly */
+ *          * we can't query CK directly */
 
-        username = g_hash_table_lookup (manager->priv->sessions, session_id);
+        username = g_hash_table_lookup (manager->sessions, session_id);
         if (username == NULL) {
                 return;
         }
 
-        user = g_hash_table_lookup (manager->priv->users, username);
+        user = g_hash_table_lookup (manager->user_by_name, username);
         if (user == NULL) {
                 /* nothing to do */
                 return;
@@ -962,13 +643,14 @@
         _gdm_user_remove_session (user, session_id);
 }
 
+
 static void
 on_proxy_destroy (DBusGProxy     *proxy,
                   GdmUserManager *manager)
 {
         g_debug ("GdmUserManager: seat proxy destroyed");
 
-        manager->priv->seat_proxy = NULL;
+        manager->seat_proxy = NULL;
 }
 
 static void
@@ -977,31 +659,19 @@
         DBusGProxy      *proxy;
         GError          *error;
 
-        g_assert (manager->priv->seat_proxy == NULL);
+        g_assert (manager->seat_proxy == NULL);
 
-        error = NULL;
-        manager->priv->connection = dbus_g_bus_get (DBUS_BUS_SYSTEM, &error);
-        if (manager->priv->connection == NULL) {
-                if (error != NULL) {
-                        g_warning ("Failed to connect to the D-Bus daemon: %s", error->message);
-                        g_error_free (error);
-                } else {
-                        g_warning ("Failed to connect to the D-Bus daemon");
-                }
+        manager->seat_id = get_current_seat_id (manager->bus);
+        if (manager->seat_id == NULL) {
                 return;
         }
 
-        manager->priv->seat_id = get_current_seat_id (manager->priv->connection);
-        if (manager->priv->seat_id == NULL) {
-                return;
-        }
-
-        g_debug ("GdmUserManager: Found current seat: %s", manager->priv->seat_id);
+        g_debug ("GdmUserManager: Found current seat: %s", manager->seat_id);
 
         error = NULL;
-        proxy = dbus_g_proxy_new_for_name_owner (manager->priv->connection,
+        proxy = dbus_g_proxy_new_for_name_owner (manager->bus,
                                                  CK_NAME,
-                                                 manager->priv->seat_id,
+                                                 manager->seat_id,
                                                  CK_SEAT_INTERFACE,
                                                  &error);
 
